QGIS Application - Bug report #9365
QGIS save as SLD style for graduated styled layer different from what it's shown in QGIS
2014-01-17 03:22 AM - stefano nardone

Status: Closed

Priority: Normal

Assignee:

Category: Symbology

Affected QGIS version:2.0.1 Regression?: No

Operating System: Linux Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 17965
Description

I've found that when applying a graduated style to a layer in QGIS, if | save the style as SLD to use it in my Geoserver, then the SLD
rendered layer looks different.

So I've made a small example: IMAGE 1!

The layer contains 4 elemtents, with a feature value that is 1,2,3,4 for each.

- First color style class represents values from 1 (included) to 2 (included)
- 2nd style class represents values > 2 and <= 3 (right?)
- 3td style class represents values > 3 and <=4

but the Geoserver WMS rendered result with the same QGIS style saved as SLD is: IMAGE 2!

where the polygon with feature value = 1 is missing. In fact the exported SLD contains instruction to style values > 1 and <= 2 for the first
style class:
&lt;se:Rule&gt;
&lt;se:Name&gt;1.0000 - 2.0000&lt;/se:Name&gt;
&lt;se:Description&gt;
&lt;se:Title&gt;1.0000 - 2.0000&lt;/se:Title&gt;
&lt;/se:Description&gt;
&lt;ogc:Filter&gt;
&lt;ogc:And&gt;

&lt;ogc:PropertylsGreaterThan&gt;
&lt;ogc:PropertyName&gt;somedata&lt;/ogc:PropertyName&gt;
&lt;ogc:Literal&gt;1&lt;/ogc:Literal&gt;

&lt;/ogc:PropertylsGreaterThan&gt;

&lt;ogc:PropertylsLessThanOrEqual To&gt;
&lt;ogc:PropertyName&gt;somedata&lit;/ogc:PropertyName&gt;
&lt;ogc:Literal&gt;2&lt;/ogc:Literal&gt;

&lt;/ogc:PropertylsLessThanOrEqualTo&gt;

&lt;/ogc:And&gt;
&lt;/ogc:Filter&gt;
&lt;se:PolygonSymbolizer&gt;
&lt;se:Fill&gt;
&lt;se:SvgParameter name="fill"&gt;#edf8fb&lt;/se:SvgParameter&gt;
&lt;/se:Fill&gt;
&lt;se:Stroke&gt;
&lt;se:SvgParameter name="stroke"&gt;#000000&lt;/se:SvgParameter&gt;
&lt;se:SvgParameter name="stroke-width"&gt;0.26&lt;/se:SvgParameter&gt;

2025-04-27 12




&lt;/se:Stroke&gt;
&lt;/se:PolygonSymbolizer&gt;
&lt;/se:Rule&gt;

and this can be a problem, as | need to hand modify all the SLD I'm producing with QGIS now. Also, the label shown in QGIS is not
exported in the SLD as you can see the style do not render any layer label.

QGIS in use is 2.01 on Linux.

Is there a way to solve this?

History

#1 - 2014-01-17 03:26 AM - stefano nardone
- File IMAGE_2.png added

Please consider this pic as IMAGE 2 - Geoserver Output Saved SLD

#2 - 2015-08-05 05:13 AM - Simon Oberhammer
| have the same problem when exporting graduated styles to SLD. This issue boils down to this:
The first condition of a filter rule "fooproperty >= 0.000000 AND fooproperty <= 0.570000" is wrongly exported as "ogc:PropertylsGreaterThan" instead of

the correct "ogc:PropertylsGreaterThanOrEqualTo".

#3 - 2017-05-01 01:08 AM - Giovanni Manghi
- Easy fix? set to No
- Regression? set to No

#4 - 2017-10-14 11:35 AM - Andrea Aime
- Status changed from Open to Closed

- Description updated

- Resolution set to fixed/implemented

This has been fixed by Nyall over a year ago: commit:5¢c270ebeb0aaaaaf03c24e7d2379c89ebee7b895

in reference to #15212
